% une configuration est une liste de paires V x D (variable,valeur) representant une fonction totale  V -> D
% une symetrie est une bijection definie sur l'ensemble de toutes les configurations. On se limite ici aux symetries definies par une composition de permutations de variables et/ou de valeurs
% chaque symetrie de base est une composition (representee par deux listes) de symetries elles-memes definies par deux listes SV (composition de permutations de variables) et SD (composition de permutations de valeurs). Une symetrie peut egalement etre definie comme composition de symetries de base.

:- include('ms4.pl').

%=============SYMETRIES=================================================================

symetries((cm,3),[ident,cm3_m1,cm3_m2,cm3_s1,cm3_s2,cm3_o,cm3_rm1,cm3_r,cm3_val]).
symetries((cm,4),[ident,cm4_m1,cm4_m2,cm4_s1,cm4_s2,cm4_o,cm4_rm1,cm4_r,cm4_val,cm4_gui1,cm4_gui2,cm4_gui3,cm4_gui4,cm4_vm1,cm4_vm2,cm4_vs1,cm4_vs2,cm4_vr,cm4_vrm1,cm4_vo,cm4_vg1,cm4_vg2,cm4_vg3,cm4_vg4]).

symetrie(cm3_m1,[(1,7),(2,8),(3,9)],[]). %m1 mediane horizontale
symetrie(cm3_m2,[(1,3),(4,6),(7,9)],[]). %m2 mediane verticale
symetrie(cm3_s1,[(2,6),(1,9),(4,8)],[]). %s1 premiere diagonale
symetrie(cm3_s2,[(2,4),(3,7),(6,8)],[]). %s2 deuxieme diagonale
symetrie(cm3_o,[(1,9),(3,7),(2,8),(4,6)],[]).
symetrie(cm3_rm1,comp,[cm3_s1,cm3_m2]).  %r moins 1 (rotation inverse)
symetrie(cm3_r,comp,[cm3_s1,cm3_m1]).    %r (rotation positive)
symetrie(cm3_val,[],[(1,9),(2,8),(3,7),(4,6)]).
%pas de symetrie cm3_gui pour cm3 (equivalente a cm3_o)

symetrie(ident,[],[]).

symetrie(cm4_m1,[(1,4),(2,3),(5,8),(6,7),(9,12),(10,11),(13,16),(14,15)],[]).
symetrie(cm4_m2,[(1,13),(5,9),(2,14),(6,10),(3,15),(7,11),(4,16),(8,12)],[]).
symetrie(cm4_s1,[(9,14),(5,15),(1,16),(6,11),(2,12),(3,8)],[]).
symetrie(cm4_s2,[(5,2),(9,3),(4,13),(10,7),(14,8),(12,15)],[]).
symetrie(cm4_o,[(1,16),(6,11),(4,13),(7,10),(3,14),(2,15),(5,12),(9,8)],[]).
symetrie(cm4_r,comp,[cm4_s1,cm4_m1]).
symetrie(cm4_rm1,comp,[cm4_s1,cm4_m2]).
symetrie(cm4_val,[],[(1,16),(2,15),(3,14),(4,13),(5,12),(6,11),(7,10),(8,9)]).
symetrie(cm4_gui1,[(6,11),(7,10),(2,3),(5,9),(8,12),(14,15)],[]).
symetrie(cm4_gui2,[(1,16),(4,13),(5,8),(9,12),(2,14),(3,15)],[]).

symetrie(cm4_gui3,[(1,4),(13,16),(5,12),(9,8),(6,10),(7,11)],[]).

symetrie(cm4_gui4,[(1,13),(4,16),(2,15),(3,14),(6,7),(10,11)],[]).

symetrie(cm4_vm1,comp,[cm4_m1,cm4_val]).
symetrie(cm4_vm2,comp,[cm4_m2,cm4_val]).
symetrie(cm4_vs1,comp,[cm4_s1,cm4_val]).
symetrie(cm4_vs2,comp,[cm4_s2,cm4_val]).
symetrie(cm4_vr,comp,[cm4_r,cm4_val]).
symetrie(cm4_vrm1,comp,[cm4_rm1,cm4_val]).
symetrie(cm4_vo,comp,[cm4_o,cm4_val]).
symetrie(cm4_vg1,comp,[cm4_gui1,cm4_val]).
symetrie(cm4_vg2,comp,[cm4_gui2,cm4_val]).
symetrie(cm4_vg3,comp,[cm4_gui3,cm4_val]).
symetrie(cm4_vg4,comp,[cm4_gui4,cm4_val]).

% 24 elements ?  dans le groupe a partir de 13 fonctions symetriques de base

%============================etude de symeties de cm4 ========================================
%cm4_gui1,cm4_gui2,cm4_gui3,cm4_gui4 ne sont equivalentes a aucune autre
%leur carre = identite (on s'en doutait), on  retrouve le groupe geometrique
% m1.val = nouvelle sym, idem avec m2,s1,s2,r,rm1,o,gui1,2,,3,4
% val.m1 = nouvelle sym, idem avec m2,s1,s2,r,rm1,o,gui1,2,,3,4 produit commutatif donc carre = ident
% gui1.gui2 = o  = gui3.gui4 = gui4.gui3 = gui2.gui1
% gui1.gui3 = m1 = gui3.gui1 = gui2.gui4 = gui4.gui2 
% gui1.gui4 = m2 = gui4.gui1 = gui2.gui3 = gui3.gui2
% on en deduit (et verifie):
% gui1.m1 = m1.gui1 = gui3 ... et {o,m1,m2,g1,2,3,4} forment un ss groupe
% gui1.s1 = s1.gui1 = ? 
%combien de nouveaux elements cela genere-t-il?
% vm2.gui1 = vg4 commutatif
% vg1.vg2 = o commutatif

%===============CONFIGURATIONS==================================================================

config(test,[(1,1),(2,2),(3,3),(4,4),(5,5),(6,6),(7,7),(8,8),(9,9)]).
config(test2,[(9,1),(8,2),(7,3),(6,4),(5,5),(4,6),(3,7),(2,8),(1,9)]).
config(test3,[(1,1),(2,6),(3,12),(4,15),(5,16),(6,11),(7,5),(8,2),(9,13),(10,10),(11,8),(12,3),(13,4),(14,7),(15,9),(16,14)]).


%===================TESTS (correction des symetries)=========================================================

% sym de valeur 1 fois cscm(4,[1,2,15,16,12,14,3,5,13,7,10,4,8,11,6,9],C),vue((cm,4),C),capply([cm4_val],C,C1),vue((cm,4),C1).
% sym de valeur 2 fois = i cscm(4,[1,2,15,16,12,14,3,5,13,7,10,4,8,11,6,9],C),vue((cm,4),C),capply([cm4_val,cm4_val],C,C1),vue((cm,4),C1).
%teste correction symetrie cm4_val cscm(4,[1,2,15,16,12,14,3,5,13,7,10,4,8,11,6,9],C),vue((cm,4),C),capply([cm4_val],C,C1),vue((cm,4),C1),cqsort(C1,C2),cscm(4,Sol,C2),ms4(Sol),write('yes!'),nl. 
%teste composition cscm(4,[1,2,15,16,13,14,3,4,12,7,10,5,8,11,6,9],C),vue((cm,4),C),capply([cm4_val,cm4_mv],C,C1),vue((cm,4),C1),cqsort(C1,C2),cscm(4,Sol,C2),ms4(Sol),write('yes!'),nl. 
%compare((cm,3),[ident],[cm_r],Lres,disp).
%sol(cm,4,Sol),cscm(4,Sol,C),capply(Sym1,C,C1),capply(Sym2,C,C2),cequal(C1,C2)
%infersym((cm,3),[cm3_r,cm3_r],SymInf).

%===================RESULTATS (algebre)=========================================================

%compare((cm,4),[cm4_val,cm4_val],[ident],Res,disp). yes tjrs
%compare((cm,4),[cm4_val,cm4_mv],[ident],Res,disp). no, yes parfois: Res = [yes,yes,no,yes,yes,yes,yes,no,no,no,no,yes,yes,yes,yes,yes,yes,yes,yes,no,no,no,no,no,no,no,no,no,no,no,no,no,no,no,no,yes,yes,yes,yes,no,no,no,no,yes,yes,yes,yes,yes,yes,yes,yes,yes,yes] 

%compare((cm,3),[cm3_val],[cm3_mh],Res,disp). no tjrs
%| ?- infersym((cm,4),[cm4_val],SymInf),fail.
%Fin d'inference
%
%(3560 ms) no
%| ?- infersym((cm,4),[cm4_gui],SymInf),fail.
%Fin d'inference
%
%(3110 ms) no  
%| ?- infersym((cm,4),[cm4_r,cm4_r],SymInf),fail.
%symetrie inferee: [cm4_o]
%Fin d'inference
%
%(7860 ms) no
%| ?- infersym((cm,4),[cm4_val,cm4_m2],SymInf),fail.
%Fin d'inference
%
%%(5330 ms) no
%| ?- infersym((cm,4),[cm4_val,cm4_m1],SymInf),fail.
%Fin d'inference
%
%(5300 ms) no
%| ?- infersym((cm,4),[cm4_r,cm4_r,cm4_r],SymInf),fail.
%symetrie inferee: [cm4_rm1]
%Fin d'inference
%
%(10890 ms) no
%| ?- infersym((cm,4),[cm4_val,cm4_gui],SymInf),fail.
%%Fin d'inference
   
%=================================================================================

%echantillon de solutions du  carre magique 4 (cm4)
sol((cm,4),[1,2,15,16,12,14,3,5,13,7,10,4,8,11,6,9]).
sol((cm,4),[1,2,15,16,13,14,3,4,12,7,10,5,8,11,6,9]).
sol((cm,4),[1,2,16,15,13,14,4,3,12,7,9,6,8,11,5,10]).
sol((cm,4),[1,3,14,16,10,13,4,7,15,6,11,2,8,12,5,9]).
sol((cm,4),[1,3,14,16,12,13,4,5,15,8,9,2,6,10,7,11]).
sol((cm,4),[1,3,14,16,15,13,4,2,10,6,11,7,8,12,5,9]).
sol((cm,4),[1,3,14,16,15,13,4,2,12,8,9,5,6,10,7,11]).
sol((cm,4),[1,3,16,14,8,15,2,9,13,6,11,4,12,10,5,7]).
sol((cm,4),[1,3,16,14,12,15,2,5,13,10,7,4,8,6,9,11]).
sol((cm,4),[1,3,16,14,13,15,2,4,8,6,11,9,12,10,5,7]).
sol((cm,4),[1,3,16,14,13,15,2,4,12,10,7,5,8,6,9,11]).
sol((cm,4),[1,4,13,16,8,14,3,9,15,5,12,2,10,11,6,7]).
sol((cm,4),[1,4,13,16,8,15,2,9,14,5,12,3,11,10,7,6]).
sol((cm,4),[1,4,13,16,12,14,3,5,15,9,8,2,6,7,10,11]).
sol((cm,4),[1,4,13,16,12,15,2,5,14,9,8,3,7,6,11,10]).
sol((cm,4),[1,4,13,16,14,15,2,3,8,5,12,9,11,10,7,6]).
sol((cm,4),[1,4,13,16,14,15,2,3,12,9,8,5,7,6,11,10]).  
sol((cm,4),[1,4,13,16,15,14,3,2,8,5,12,9,10,11,6,7]).
sol((cm,4),[1,4,13,16,15,14,3,2,12,9,8,5,6,7,10,11]).
sol((cm,4),[1,4,14,15,9,12,6,7,16,5,11,2,8,13,3,10]).
sol((cm,4),[1,4,14,15,13,16,2,3,8,5,11,10,12,9,7,6]).
sol((cm,4),[1,4,14,15,13,16,2,3,12,9,7,6,8,5,11,10]).
sol((cm,4),[1,4,14,15,16,11,5,2,9,6,12,7,8,13,3,10]).
sol((cm,4),[1,4,14,15,16,13,3,2,7,6,12,9,10,11,5,8]).
sol((cm,4),[1,4,14,15,16,13,3,2,11,10,8,5,6,7,9,12]).
sol((cm,4),[1,4,15,14,9,12,7,6,16,5,10,3,8,13,2,11]).
sol((cm,4),[1,4,15,14,13,16,3,2,8,5,10,11,12,9,6,7]).
sol((cm,4),[1,4,15,14,13,16,3,2,12,9,6,7,8,5,10,11]).
sol((cm,4),[1,4,15,14,16,10,5,3,9,7,12,6,8,13,2,11]). 
sol((cm,4),[1,4,15,14,16,13,2,3,6,7,12,9,11,10,5,8]).
sol((cm,4),[1,4,15,14,16,13,2,3,10,11,8,5,7,6,9,12]).
sol((cm,4),[1,4,16,13,14,15,3,2,7,6,10,11,12,9,5,8]).
sol((cm,4),[1,4,16,13,14,15,3,2,11,10,6,7,8,5,9,12]).
sol((cm,4),[1,4,16,13,15,14,2,3,6,7,11,10,12,9,5,8]).
sol((cm,4),[1,4,16,13,15,14,2,3,10,11,7,6,8,5,9,12]).
sol((cm,4),[1,5,12,16,10,11,6,7,15,4,13,2,8,14,3,9]).
sol((cm,4),[1,5,12,16,14,11,6,3,15,8,9,2,4,10,7,13]).
sol((cm,4),[1,5,12,16,15,11,6,2,10,4,13,7,8,14,3,9]).
sol((cm,4),[1,5,12,16,15,11,6,2,14,8,9,3,4,10,7,13]).
sol((cm,4),[1,5,16,12,8,14,3,9,10,4,13,7,15,11,2,6]).
sol((cm,4),[1,5,16,12,10,14,3,7,8,4,13,9,15,11,2,6]).  
sol((cm,4),[1,5,16,12,10,14,3,7,15,11,6,2,8,4,9,13]).
sol((cm,4),[1,5,16,12,15,14,3,2,10,11,6,7,8,4,9,13]).
sol((cm,4),[1,6,11,16,7,15,2,10,14,4,13,3,12,9,8,5]).
sol((cm,4),[1,6,11,16,8,12,5,9,15,3,14,2,10,13,4,7]).
sol((cm,4),[1,6,11,16,8,15,2,9,12,3,14,5,13,10,7,4]).
sol((cm,4),[1,6,11,16,12,10,7,5,13,3,14,4,8,15,2,9]).
sol((cm,4),[1,6,11,16,12,15,2,5,8,3,14,9,13,10,7,4]).
sol((cm,4),[1,6,11,16,12,15,2,5,14,9,8,3,7,4,13,10]).
sol((cm,4),[1,6,11,16,13,10,7,4,12,3,14,5,8,15,2,9]).
sol((cm,4),[1,6,11,16,14,12,5,3,15,9,8,2,4,7,10,13]).
sol((cm,4),[1,6,11,16,14,15,2,3,7,4,13,10,12,9,8,5]).
sol((cm,4),[1,6,11,16,14,15,2,3,12,9,8,5,7,4,13,10]).  
%...

sol((cm,3),[2,7,6,9,5,1,4,3,8]). 
sol((cm,3),[2,9,4,7,5,3,6,1,8]).
sol((cm,3),[4,3,8,9,5,1,2,7,6]).
sol((cm,3),[4,9,2,3,5,7,8,1,6]).
sol((cm,3),[6,1,8,7,5,3,2,9,4]).
sol((cm,3),[6,7,2,1,5,9,8,3,4]).
sol((cm,3),[8,1,6,3,5,7,4,9,2]).
sol((cm,3),[8,3,4,1,5,9,6,7,2]).
 
%=======================================================================================

%is_a_sym(PB,Sym,Rep) teste (mais ne prouve pa)s qu'une fonction +Sym eventuellement composee, i.e. liste de fonction) de +PB est bien une symetrie (Rep = yes)

is_a_sym(PB,Sym,yes):- findall(Res, testsym(PB,Sym,Res), Lres), allyes(Lres),!.
is_a_sym(_,_,no).

testsym((cm,N),Sym,Rep):- sol((cm,N),Sol),cscm(N,Sol,C), app_and_verif((cm,N),Sym,C,Rep).
app_and_verif((cm,N),Sym,C,yes):- capply(Sym,C,C1), cqsort(C1,C2), cscm(N,Sol2,C2), ms4(Sol2),!.
app_and_verif(_,_,_,no).

%infersym(+PB,+SymO,?SymInf) tente de trouver une symetrie simple SymInf posssiblement equivalente a SymO. Sym0 est une liste composition de symetries. Pour avoir tt les possibilites d'un coup faire par exemple infersym((cm,4),[cm4_gui4],S),fail.

infersym(PB,SymO,SymInf):- initcount,symetries(PB,LSym),testinclude(SymO,LSym,yes),trysym(PB,LSym,SymO,SymInf), write('symetrie inferee: '), write(SymInf),nl,fail.
infersym(PB,SymO,_):- symetries(PB,LSym),testinclude(SymO,LSym,no),!,write('erreur d''ennonce: '), write(SymO).
infersym(_,_,_):- counter(N), N>0, write('Fin d''inference'),nl,!.
infersym(_,_,_):- counter(0), write('Pas de symetrie inferee'),nl.

trysym(PB,[Sym|_],SymO,[Sym]) :- compare(PB,SymO,[Sym],Lres,nodisp), allyes(Lres),\+SymO=[Sym], incrcount .
trysym(PB,[_|Lsym],SymO,SymI) :- trysym(PB,Lsym,SymO,SymI).
                                 
allyes([yes]).
allyes([yes|L]) :- allyes(L).

testinclude(SymO,LSym,yes) :- include(SymO,LSym).
testinclude(SymO,LSym,no):- \+include(SymO,LSym).

include([],_).
include([E|L],M):- member(E,M),include(L,M).

initcount :- retract(counter(_)), asserta(counter(0)),!.
initcount :- asserta(counter(0)).

incrcount :- retract(counter(N)), N1 is N+1, asserta(counter(N1)).

%compare teste le resultat Lres de l'application de deux symetries a un ensemble de solutions. Si Lres n'a que des 'yes' on a des chances que les deux symetries soient equivalentes. Si on a des 'no' ce n'est pas le cas. Nota: compare ne peut etre utilise directement pour inferer des symetries.

compare(PB,Sym1,Sym2,Lres,Disp):- findall(Res, compare1(PB,Sym1,Sym2,Res,Disp), Lres).
compare1((cm,N),Sym1,Sym2,Res,Disp) :- sol((cm,N),Sol),cscm(N,Sol,C),capply(Sym1,C,C1),capply(Sym2,C,C2),test_cequal(C1,C2,Res),follow((cm,N),Res,C1,C2,Disp).

test_cequal(C1,C2,yes):- cequal(C1,C2),!.
test_cequal(_,_,no).

follow(_,yes,_,_,_):-!.
follow(PB,no,C1,C2,disp) :- vue(PB,C1), write('------------'),nl, vue(PB,C2),nl. 
follow(_,no,_,_,nodisp).

%cequal(C1,C2) alors C1 et C2 sont les memes fonctions

cequal([],[]).
cequal([(V,D)|C],C1) :- extract_and_del(C1,(V,D),C2),cequal(C,C2).


%extract_and_del(C1,(V1,D),C2) si C1 est une configuration alors (V1,D) est un de ses elements et C2 est C1 avec cet element en moins.

extract_and_del([(V,D)|C],(V,D),C).
extract_and_del([(V1,D)|C1],(V2,D2),[(V1,D)|C2]) :- \+(V1=V2),
                                                    extract_and_del(C1,(V2,D2),C2).

%capply(Sym,C1,C2) si Sym est une liste de symetries et C1 une configuration, alors C2 est la configuration obtenue en applicant la suite des symetries de la liste dans l'ordre de celle-ci (la premiere appliquee d'abord)

capply([],C,C).
capply([S|L],C1,C2) :- \+list(S),!,capply_sym(S,C1,C3), capply(L,C3,C2).
capply([S|L],C1,C2) :- list(S), capply(S,C1,C3),  capply(L,C3,C2).
%xxxxx
capply_sym(S,C1,C2) :- symetrie(S,SV,SD), \+(SV=comp), capply_var(SV,C1,C3), capply_val(SD,C3,C2).
capply_sym(S,C1,C2) :- symetrie(S,comp,Compsym), capply(Compsym,C1,C2).

capply_var([],C,C).
capply_var([(V1,V2)|SV],C1,C2) :- seek_and_set_var((V1,V2),C1,C3),capply_var(SV,C3,C2).

%seek_and_set_var((V1,V2),C1,C2) si (V1,V2) est une permutation de variables et C1 une configuration, alors C2 est la configuration obtenue en permutant les variables V1 et V2 dans C1
seek_and_set_var(_,[],[]).
seek_and_set_var((V1,V2),[(V1,D)|L1],[(V2,D)|L2]) :- seek_and_set_var((V1,V2),L1,L2).
seek_and_set_var((V1,V2),[(V2,D)|L1],[(V1,D)|L2]) :- seek_and_set_var((V1,V2),L1,L2).
seek_and_set_var((V1,V2),[(V,D)|L1],[(V,D)|L2]) :- \+V=V1,\+V=V2, seek_and_set_var((V1,V2),L1,L2).

capply_val([],C,C).
capply_val([(D1,D2)|SD],C1,C2) :- seek_and_set_val((D1,D2),C1,C3),capply_val(SD,C3,C2).

%seek_and_set_val((D1,D2),C1,C2) si (D1,D2) est une permutation de valeur et C1 une configuration, alors C2 est la configuration obtenue en permutant les valeurs D1 et D2 dans C1
seek_and_set_val(_,[],[]).
seek_and_set_val((D1,D2),[(V,D1)|L1],[(V,D2)|L2]) :- seek_and_set_val((D1,D2),L1,L2).
seek_and_set_val((D1,D2),[(V,D2)|L1],[(V,D1)|L2]) :- seek_and_set_val((D1,D2),L1,L2).
seek_and_set_val((D1,D2),[(V,D)|L1],[(V,D)|L2]) :- \+D=D1,\+D=D2, seek_and_set_val((D1,D2),L1,L2).


vue((cm,N),C) :- testcm(N,C),cqsort(C,CS), write('------------------'),nl,vuecarre(N,CS),
                                         write('------------------'),nl,!.
vue((cm,N),C) :- write('erreur de configuration: '),write(C),nl,write('N =  '), write(N),nl,
               length(C,N1), write('N should be: '), N2 is sqrt(N1), write(N2), nl.

testcm(N,C) :- length(C,X), X is N*N.

vuecarre(_,[]).
vuecarre(N,C) :- length(NP,N),append(NP,R,C),cwrite(NP),nl,vuecarre(N,R).

cwrite([]).
cwrite([(_,D)|L]) :- write(D),write('   --'),cwrite(L).

cqsort([],[]).
cqsort([E|L],M) :- cpartition(E,L,P1,P2),
                   cqsort(P1,L1), cqsort(P2,L2),
                   append(L1,[E|L2],M).

cpartition(_,[],[],[]).
cpartition((V,D),[(V1,D1)|L],[(V1,D1)|L1],L2)  :- V1 < V, cpartition((V,D),L,L1,L2).
cpartition((V,D),[(V1,D1)|L],L1,[(V1,D1)|L2])  :- V < V1, cpartition((V,D),L,L1,L2).

%cscm (convert_sol_carre_magique) (N,Sol,C)  N taille, sol solution, C configuration.
% appel: cscm(n,sol,C). Nota: reversible avec C triee par cqsort

cscm(N,Sol,C) :- M is N*N, cscm1(M,1,Sol,C).
cscm1(N,N,[D],[(N,D)]):- !.
cscm1(N,I,[D|Sol],[(I,D)|C]) :- I1 is I+1, cscm1(N,I1,Sol,C).

